<%@ page import="java.io.File" errorPage="err.jsp" %>
<%@ taglib uri="gnat" prefix="gnat" %>
<%-- 
    Use the Servlet 2.2+ temporary working directory to demo some file stuff.  
    Makes it easier because the user doesn't have to configure anything and I 
    don't have to worry about file system and user permissions for the demo.
  
    See section 3.7 of Servlet 2.3 spec for description of this attribute.
--%>
<%! File tempdir = null; %>   
<%  tempdir = (File)application.getAttribute("javax.servlet.context.tempdir"); %>
<html>
<head>
<title>Gnat JSP Taglib</title>
 <link type="text/css" href="examples.css" rel="stylesheet"> 
</head>
<body>
<h1>Gnat Taglib</h1>

<%-- Until JRun and Jasper escape String literals nested in custom tag attributes
     properly, it's best to declare them as variables and then use their variable
     names rather than the literal strings.  The multitude of double quotations
     seems to confuse JRun (3.0, SP1) and Jasper (3.3.dev), though JRun can deal
     with them if the quotes around the whole attribute are removed.
--%>
<%-- Name of flat file to create in demo --%>
<% final String foo = "/foo-file.txt"; %>
<ol>
    <li><p class="tag">&lt;gnat:deltree dir="dirname"/&gt;</p>
      <ul>
        <li>Deletes a directory and all its files and subdirectories. Careful with this one! <a href="deltree.jsp">deltree examples</a>
        </li>
      </ul>
    </li>
    <li><p class="tag">&lt;gnat:ls dir="/absolute/file/path" id="foo"&gt;</p>
      <ul>
        <li>Gets a directory listing and returns a NESTED scope scripting variable for looping through the results.  See <a href="ls.jsp">ls examples</a>
        </li>
      </ul>
    </li>
    <li><p class="tag">&lt;gnat:echo message=""/&gt; : <gnat:echo message="Hello, World!"/></p>
      <ul>
        <li>Echoes a message to the JSP output stream or a file. See more examples at <a href="echo.jsp">echo examples</a>
        </li>
      </ul>
    </li>

    <li><p class="tag">&lt;gnat:touch file="/file/to/touch" millis="modtime in millis" datetime="modtime date format"/&gt;</p>
      <ul>
        <li>
        Updates the last-modified time on a file, creating the file if necessary.  See <a href="touch.jsp">touch examples</a>
        </li>
      </ul>
    </li>
<gnat:touch file="<%= tempdir+foo %>"/>

    <li><p class="tag">&lt;gnat:fail message=""/&gt;</p>
      <ul>
        <li>
        Exits the current JSP (just throwing a JspTagException), optionally printing
        additional information via the <i>message</i> attribute.
    
        <p><u>Note:</u> This tag is called at the bottom of this page so as not to disrupt the
        processing of the rest of the tag examples on the page.</p></li>
      </ul>
    </li>
    
    <li><p class="tag">&lt;gnat:gzip src="/path/to/file" zipfile="filename.zip"/&gt;</p>
      <ul>
        <li>GZips a file.  The <i>src</i> file is zipped with whatever name and extension
        is given in the <i>zipfile</i> attribute.</li>
      </ul>
    </li>
<%-- Name of the file when zipped. --%>
<% final String foozip = foo + ".gz"; %>
<gnat:gzip src="<%= tempdir+foo %>" zipfile="<%= tempdir+foozip %>"/>


    <li><p class="tag">&lt;gnat:mkdir dir="/directory(ies)/to/create" clobber="true"/&gt;</p>
      <ul>
        <li>Creates a single directory or a tree of directories if parent directories 
        of the bottom-most directory do not exist.  Does nothing if the directory(ies) 
        already exist, unless the optional clobber attribute is set to true, in which case
        the old directory is forcibly deleted along with any subdirectories and files, and
        the new directory(ies) created.</li>
      </ul>
    </li>
<%-- Names of directories to create and place the unzipped file under.. --%>
<% final String foodir = "/foodir/bar/baz/pickles"; %>
<gnat:mkdir dir="<%= tempdir+foodir %>" clobber="true"/>


    <li><p class="tag">&lt;gnat:gunzip src="/path/to/file.gz" dest="[ filename | directory ]"/&gt;</p>
      <ul>
        <li>GUnzips a file. The <i>dest</i> attribute is optional and can be a directory 
        to unzip the file into, or can be a new file name.  If <i>dest</i> is 
        omitted, the parent dir of <i>src</i> is taken as the destination (i.e., 
        a copy of the file is unzipped in its current directory). The file is only 
        expanded if the <i>src</i> file is newer than the <i>dest</i> file, or 
        when the <i>dest</i> file does not exist.</li>
      </ul>
    </li>
<%-- New name of the file when unzipped. --%>
<% final String foounzip = foo + ".unzipped.txt"; %>
<gnat:gunzip src="<%= tempdir+foozip %>" dest="<%= tempdir+foodir+foounzip %>" />
    
    <li><p class="tag">&lt;gnat:tstamp/&gt;</p>
      <ul>
        <li>Sets the DSTAMP, TSTAMP and TODAY properties in the current page. 
        The DSTAMP is in the "yyyymmdd" format, the TSTAMP is in the "hhmm" 
        format and TODAY is "month day year".  All three are scripting variables.  
        See also <a href="tstamp.jsp">tstamp example</a></li> 
      </ul>
    </li>
</ol>

<hr align="center" width="60%" />
</body>
</html>
<%-- Call the fail tag last --%>
 <gnat:fail message="Page Failed!"/>
