<%@ taglib uri="http://jakarta.apache.org/taglibs/i18n-1.0" prefix="i18n" %>
<i18n:bundle baseName="org.apache.taglibs.i18n.i18n-test"
             id="bundle1"/>

<i18n:bundle baseName="org.apache.taglibs.i18n.i18n-test2"
             id="bundle2"/>

<HTML>
<HEAD>
  <TITLE>Examples of I18N Custom Tag Library Tag Usage</TITLE>
</HEAD>
<BODY>

This page shows how multiple bundles can be used together by declaring
scripting variables and by nesting the i18n:message tags inside an
i18n:bundle tag. It also shows various ways of specifying the locale
to an i18n:bundle tag.
<hr/>
Bundles that define scripting variables can be accessed by message tags
with a <b>bundleRef</b> attribute. Both bundles below use the default
browser locale for the bundle.
<pre>
&lt;i18n:bundle baseName="org.apache.taglibs.i18n.i18n-test"
             id="bundle1"/&gt;
&lt;i18n:bundle baseName="org.apache.taglibs.i18n.i18n-test2"
             id="bundle2"/&gt;
default:test1 = &lt;i18n:message key="test1"/&gt;&lt;br/&gt;
bundle1:test1 = &lt;i18n:message bundleRef="bundle1" key="test1"/&gt;&lt;br/&gt;
bundle2:test1 = &lt;i18n:message bundleRef="bundle2" key="test1"/&gt;&lt;br/&gt;
</pre>
default:test1 = <i18n:message key="test1"/><br/>
bundle1:test1 = <i18n:message bundleRef="bundle1" key="test1"/><br/>
bundle2:test1 = <i18n:message bundleRef="bundle2" key="test1"/><br/>
<hr/>
Message nested inside a bundle tag - locale from session. (<%= session.getAttribute("userLocale") %>)
  <pre>
  &lt;i18n:bundle baseName="org.apache.taglibs.i18n.i18n-test"
               localeRef="userLocale"&gt;
    &lt;i18n:message key="test1"/&gt;
  &lt;/i18n:bundle&gt;
  </pre>
<i>
<i18n:bundle baseName="org.apache.taglibs.i18n.i18n-test"
             localeRef="userLocale">
  <i18n:message key="test1"/>
</i18n:bundle>
</i>
<hr/>
Message nested inside a bundle tag - locale from browser.  (<%= bundle1.getLocale() %>)
  <pre>
  &lt;i18n:bundle baseName="org.apache.taglibs.i18n.i18n-test"&gt;
    &lt;i18n:message key="test1"/&gt;
  &lt;/i18n:bundle&gt;
  </pre>
<i>
<i18n:bundle baseName="org.apache.taglibs.i18n.i18n-test">
  <i18n:message key="test1"/>
</i18n:bundle>
</i>
<hr/>
Message nested inside a bundle tag - locale hardcoded. (Locale.US)
  <pre>
  &lt;i18n:bundle baseName="org.apache.taglibs.i18n.i18n-test"&gt;
               locale="&lt;%= java.util.Locale.US %&gt;"&gt;
    &lt;i18n:message key="test1"/&gt;
  &lt;/i18n:bundle&gt;
  </pre>
<i>
<i18n:bundle baseName="org.apache.taglibs.i18n.i18n-test"
             locale="<%= java.util.Locale.US %>">
  <i18n:message key="test1"/>
</i18n:bundle>
</i>
</BODY>
</HTML>
