<html>
<head>
<title>IO JSP Taglib</title>
 <link type="text/css" href="examples.css" rel="stylesheet"> 
</head>
<body>
<h1>IO Taglib</h1>

<p>Welcome to the IO tag library which makes it easy to do 
URL requests via JSP custom tags. 
Current protocols supported are the file system, FTP, HTTP, HTTPS, XMLRPC and SOAP.
Here are some examples
</p>

<h2>Simple URL demos</h2>

<p>These demos all perform simple URL requests such as HTTP GETs of external content.
</p>

<ul>
  <li><a href="file.jsp">load a file via the file system</a></li>
  <li><a href="jakarta.jsp">load the Jakarta Home Page via HTTP</a></li>
  <li><a href="quote.jsp?symbols=SUNW+IBM">get XML Stock Quotes via HTTP</a></li>
  <li><a href="file_write.jsp">write a temporary file from the content of a HTTP request then read it back again.</a></li>
  <li><a href="ftp.jsp">load a file via FTP</a></li>
</ul>


<h2>HTTP POST demos</h2>

<p>These demos all perform HTTP POST requests to SOAP web services and 
return XML documents ready for styling into some other format.
</p>

<ul>
  <li><a href="fortune.jsp">Fortune cookie</a></li>
  <li><a href="babelfish.jsp">Babelfish</a></li>
  <li><a href="pipe.jsp">Pipeline</a> : pipes the result of a HTTP post into an XML-RPC call</li>
</ul>


<h2>XML RPC demos</h2>

<p>These demos all use the &lt;io:xmlrpc&gt; tag to peform XML-RPC requests on
web services and return XML documents ready for styling into some other format.
</p>

<ul>
  <li><a href="xmlrpc.jsp">Sample XML-RPC request echo</a></li>
</ul>



<h2>SOAP demos</h2>

<p>These demos all use the &lt;io:soap&gt; tag to peform SOAP requests on
web services and return XML documents ready for styling into some other format.
</p>

<h3>MarketWatch</h3>

<ul>
  <li><a href="marketwatch/market_indices.jsp">Market Indices</a></li>
  <li><a href="marketwatch/news_headlines.jsp">News Headlines</a></li>
  <li><a href="marketwatch/quote.jsp">Quote</a></li>
  <li><a href="marketwatch/symbol_info.jsp">Symbol Information</a></li>
</ul>

<h3>General</h3>

<ul>
  <li><a href="soap.jsp">Sample SOAP request echo</a></li>
  <li><a href="soap/babelfish.jsp">Babelfish</a></li>
  <li><a href="soap/babelfish2.jsp">Babelfish (alternative)</a></li>
  <li><a href="soap/fortune.jsp">Fortune cookie</a></li>
</ul>

<hr align="center" width="60%" />
</body>
</html>
