<!doctype html public "-//w3c//dtd html 4.0 transitional//en">
<html>
<%@ taglib uri="http://jakarta.apache.org/taglibs/xtags-1.0" prefix="xtags" %>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
<title>RSS Styling Demo</title>
<link rel="stylesheet" href="examples.css" type="text/css">
</head>
<body>

<% 
    String symbols = request.getParameter( "symbols" );
    if ( symbols == null ) {
        symbols = "ORCL+IBM+SUNW";
    }
    else {
        symbols = symbols.replace( ' ', '+' );
    }
    // note this URL should only be used for development!
    String url = "http://www.xmltoday.com/examples/stockquote/getxmlquote.vep?s=" + symbols;
%>

<p>This example demonstrates fetching XML stock quotes from a web service 
and formatting the results using the XTags library.</p>



<h2>Stock Codes</h2>

<form METHOD="GET" ACTION="<%= request.getRequestURI() %>">

  Enter symbol(s): 

  <input type="text" name="symbols" value="<%= symbols %>"/>

  &nbsp;&nbsp;

  <input type="submit" value="Get Quotes"/>
</form>



<h2>Stock Quotes</h2>

<xtags:parse url="<%= url %>"/>

<table cellspacing="0" cellpadding="2" bgcolor="#000000" border="1">
  <tr bgcolor="#dddddd">
    <th>Symbol</th>
    <th align="right">Ask</th>
    <th align="right">Open</th>
    <th align="right">Days High</th>
    <th align="right">Days Low</th>
    <th align="right">Price Change</th>
    <th align="right">Volume</th>
    <th>Date</th>
    <th>Time</th>
  </tr>

  <xtags:forEach select="//stock_quote">
    <tr bgcolor="#eeeeee">
      <td>
        <xtags:valueOf select="symbol"/>
      </td>
      <td align="right">
        <xtags:valueOf select="price[@type='ask']/@value"/>
      </td>
      <td align="right">
        <xtags:valueOf select="price[@type='open']/@value"/>
      </td>
      <td align="right">
        <xtags:valueOf select="price[@type='dayhigh']/@value"/>
      </td>
      <td align="right">
        <xtags:valueOf select="price[@type='daylow']/@value"/>
      </td>
      <td align="right">
        <xtags:valueOf select="change"/>
      </td>
      <td align="right">
        <xtags:valueOf select="volume"/>
      </td>
      <td>
        <xtags:valueOf select="when/date"/>
      </td>
      <td>
        <xtags:valueOf select="when/time"/>
      </td>
    </tr>
  </xtags:forEach>
</table>

</body>
</html>
