<!doctype html public "-//w3c//dtd html 4.0 transitional//en">
<html>
<%@ taglib uri="http://jakarta.apache.org/taglibs/xtags-1.0" prefix="xtags" %>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
<title>Test Add Example</title>
<link rel="stylesheet" href="examples.css" type="text/css">
</head>

<body>

<h1>Test Replace Example</h1>

<p>This demo tests the use of the &lt;xtags:replace&gt; tag to replace nodes in an XML document
with XML fragments.</p>


<hr/>

<xtags:parse>
  <a x="1" y="1">
    <b>
      <c d="123" e="456">
        <foo>abcd</foo>
      </c>
    </b>
    <d x="33" y="99">
      <foo>whoo</foo>
      <e x="234" y="4912">
        <foo>def</foo>
      </e>
    </d>
  </a>
</xtags:parse>


<h2>Before Replacements</h2>

<xtags:copyOf select="/"/>

<hr/>


<h2>After Replacements</h2>


<xtags:forEach select="//foo">
  <xtags:replace>
    <something>which should 
        <with even="more">have replaced all foo elements</with>
        <empty/>
    </something>
  </xtags:replace>
</xtags:forEach>


<xtags:forEach select="//b">
  <xtags:replace>
    Text that replaces a b node
  </xtags:replace>
</xtags:forEach>


<xtags:copyOf select="/"/>

<h2>Replacing a single node with multiple nodes</h2>

<p>Replacing the &lt;empty&gt; nodes:</p>
<xtags:forEach select="//empty">
  <xtags:replace>
    <full> node </full>
    with text
    <and>another node</and>
  </xtags:replace>
</xtags:forEach>

<xtags:copyOf select="/"/>

<h2>Replacing the root element</h2>

<xtags:forEach select="/a">
    <xtags:replace>
        <root>A new ro<sdsd/>ot node</root>
    </xtags:replace>
</xtags:forEach>

<xtags:copyOf select="/"/>

<h2>Replacing the root node</h2>

<xtags:context select="/">
    <xtags:replace>
        <!-- a comment -->
        <root>Another root node</root>
    </xtags:replace>
</xtags:context>

<xtags:context select="/">
    <xtags:replace><?xml version="1.0"?>
        <!-- a comment -->
        <root>Another root node <foo>with</foo> an <foo>xml</foo> declaration</root>
    </xtags:replace>
</xtags:context>

<%
  try {
%>

<xtags:context select="//foo">
    <xtags:replace><?xml version="1.0"?>
        <!-- a comment -->
        <root>Another root node with an xml declaration</root>
    </xtags:replace>
</xtags:context>

<%
  } catch (Exception e) {
%>
  <p>Exception - should say too many context nodes: <pre><%= e.getMessage() %></pre></p>
<%
  }
%>

<xtags:copyOf select="/"/>

<hr/>

</body>
</html>
