<!doctype html public "-//w3c//dtd html 4.0 transitional//en">
<%@ taglib uri="http://jakarta.apache.org/taglibs/xtags-1.0" prefix="xtags" %>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
<title>Test &lt;xtags:stylesheet&gt;</title>
<link rel="stylesheet" href="../examples.css" type="text/css">
</head>

<body>

<h1>Test &lt;xtags:stylesheet&gt;</h1>


<xtags:parse uri="../much_ado.xml" id="mydoc"/>


<% long start = System.currentTimeMillis(); %>
<xtags:stylesheet>

    <xtags:template match="TITLE">
        <h2><xtags:applyTemplates/></h2>
    </xtags:template>


    <xtags:template match="PERSONA">
        <em><xtags:valueOf select="."/></em><br/>
    </xtags:template>

    <xtags:template match="PERSONA[.='LEONATO']">
        <em><xtags:valueOf select="."/> (Our hero!)</em><br/>
    </xtags:template>

    <xtags:template match="PGROUP">
        <div style="margin-top: 1px; margin-botton: 1px">
            <xtags:applyTemplates/>
        </div>
    </xtags:template>

    <xtags:template match="PGROUP/GRPDESCR">
        &nbsp;&nbsp;<small><xtags:applyTemplates/></small>
    </xtags:template>


    <xtags:template match="SCENE"  avt="true">
        Scene {TITLE} (that's {TITLE}), in which 
        you need to {STAGEDIR} with a stiff upper lip
        <table border="0">
            <tr><td colspan="2">
                <h3><xtags:valueOf select="TITLE"/></h3>
                <em><xtags:valueOf select="STAGEDIR"/></em>
                </td>
            </tr>
            <xtags:applyTemplates/>
        </table>
    </xtags:template>

    <xtags:template match="SPEECH">
        <tr>
            <td><xtags:applyTemplates select="SPEAKER"/></td>
            <td><xtags:applyTemplates select="LINE"/></td>
        </tr>
    </xtags:template>

    <xtags:template match="LINE">
        <xtags:valueOf select="position()"/>
        <xtags:valueOf select="last()"/>
        <xtags:applyTemplates/><br/>
    </xtags:template>

    <xtags:template match="SPEAKER">
        <b><xtags:valueOf select="."/></b>
    </xtags:template>

    <xtags:template match="SPEAKER[.='LEONATO']">
        <b><u><xtags:valueOf select="."/></u></b>
    </xtags:template>

</xtags:stylesheet>
<% 
    long elapsed = System.currentTimeMillis() - start;
    System.out.println("Time to execute <xtags:stylesheet>: "+elapsed);

    start = System.currentTimeMillis();
%>

<%--

<xtags:style xsl="test_stylesheet.xsl" document="<%= mydoc %>"/>


<% 
    elapsed = System.currentTimeMillis() - start;
    System.out.println("Time to execute <xtags:style>: "+elapsed);
%>
--%>
</body>
</html>
