<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

    <xsl:output method="html"/>

    <xsl:template match="TITLE">
        <h2><xsl:apply-templates/></h2>
    </xsl:template>


    <xsl:template match="PERSONA">
        <em><xsl:value-of select="."/></em><br/>
    </xsl:template>

    <xsl:template match="PERSONA[.='LEONATO']">
        <em><xsl:value-of select="."/> (Our hero!)</em><br/>
    </xsl:template>

    <xsl:template match="PGROUP">
        <div style="margin-top: 1px; margin-botton: 1px">
            <xsl:apply-templates/>
        </div>
    </xsl:template>

    <xsl:template match="PGROUP/GRPDESCR">
        &nbsp;&nbsp;<small><xsl:apply-templates/></small>
    </xsl:template>


    <xsl:template match="SCENE">
        <table border="0">
            <tr><td colspan="2">
                <h3><xsl:value-of select="TITLE"/></h3>
                <em><xsl:value-of select="STAGEDIR"/></em>
                </td>
            </tr>
            <xsl:apply-templates/>
        </table>
    </xsl:template>

    <xsl:template match="SPEECH">
        <tr>
            <td><xsl:apply-templates select="SPEAKER"/></td>
            <td><xsl:apply-templates select="LINE"/></td>
        </tr>
    </xsl:template>

    <xsl:template match="LINE">
        <xsl:apply-templates/><br/>
    </xsl:template>

    <xsl:template match="SPEAKER">
        <b><xsl:value-of select="."/></b>
    </xsl:template>

    <xsl:template match="SPEAKER[.='LEONATO']">
        <b><u><xsl:value-of select="."/></u></b>
    </xsl:template>

</xsl:stylesheet>
