package com.taglib.authentication;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import javax.servlet.jsp.tagext.Tag;
import javax.servlet.jsp.tagext.TagSupport;

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.jsp.JspException;

/* This version uses the base JSP custom tag API. */

public class IfLoginTagVersion1 extends TagSupport {
  private boolean status = true;
  private String role = null;
  private UserSessionManager sessionMgr = UserSessionManager.getInstance();

  public void setStatus (boolean status) {
    this.status = status;
  }
  public void setRole (String role) {
    this.role = role;
  }

  public int doStartTag () throws JspException {
    HttpServletRequest request =
      (HttpServletRequest) pageContext.getRequest();
    if (checkLogin(request) == status) {
      return Tag.EVAL_BODY_INCLUDE;
    }
    return Tag.SKIP_BODY;
  }

  public int doEndTag () throws JspException {
    return Tag.EVAL_PAGE;
  }

  private UserBean fetchUser (HttpServletRequest request) {
    return sessionMgr.getSessionUser(request);
  }
  private boolean checkLogin (HttpServletRequest request)
    throws JspException {
    UserBean user = fetchUser(request);
    if (user == null) {
      return false;
    } else {
      return checkRole(user);
    }
  }
  private boolean checkRole (UserBean user) {
    if (role == null) {
      return true;
    } else {
      return user.hasRole(role);
    }
  }

  public void release () {
    super.release();
    status = true;
    role = null;
  }
}
