package com.taglib.authentication;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.jsp.jstl.core.ConditionalTagSupport;

/* This version leverages the JSTL custom tag base classes. */

public class IfLoginTagVersion2 extends ConditionalTagSupport {
  private boolean status = true;
  private String role = null;
  private UserSessionManager sessionMgr = UserSessionManager.getInstance();

  public void setStatus (boolean status) {
    this.status = status;
  }
  public void setRole (String role) {
    this.role = role;
  }

  protected boolean condition () {
    return (checkLogin((HttpServletRequest) pageContext.getRequest()) == status);
  }

  private boolean checkLogin (HttpServletRequest request) {
    UserBean user = fetchUser(request);
    if (user == null) {
      return false;
    } else {
      return checkRole(user);
    }
  }
  private boolean checkRole (UserBean user) {
    if (role == null) {
      return true;
    } else {
      return user.hasRole(role);
    }
  }

  private UserBean fetchUser (HttpServletRequest request) {
    return sessionMgr.getSessionUser(request);
  }

  public void release () {
    super.release();
    status = true;
    role = null;
  }
}
