package com.taglib.authentication;

import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpSessionEvent;
import javax.servlet.http.HttpSessionListener;
import javax.servlet.http.HttpSessionBindingEvent;
import javax.servlet.http.HttpSessionAttributeListener;
import java.util.Date;

public class LoginSessionListener
  implements javax.servlet.http.HttpSessionListener, HttpSessionAttributeListener {

  public void sessionCreated (javax.servlet.http.HttpSessionEvent event) {
    javax.servlet.http.HttpSession session = event.getSession();
    System.out.println(new java.util.Date().toString() + ": session created"
		       + " (" + session.getId() + ")");
  }
  public void sessionDestroyed (javax.servlet.http.HttpSessionEvent event) {
    javax.servlet.http.HttpSession session = event.getSession();
    System.out.println(new java.util.Date().toString() + ": session destroyed"
		       + " (" + session.getId() + ")");
  }

  public void attributeReplaced (javax.servlet.http.HttpSessionBindingEvent event) {
    /* No-op. */
    dbgSBE("attributeReplaced()", event);
  }
  public void attributeAdded (javax.servlet.http.HttpSessionBindingEvent event) {
    dbgSBE("attributeAdded()", event);
    javax.servlet.http.HttpSession session = event.getSession();
    if (event.getName().equals(com.taglib.authentication.UserSessionManager.SESSION_USER_ATTRIBUTE)) {
      com.taglib.authentication.UserBean user = (com.taglib.authentication.UserBean) event.getValue();
      System.out.println(new java.util.Date().toString()
			 + ": session login for " + user.getUsername()
			 + " (" + session.getId() + ")");
    }
  }
  public void attributeRemoved (javax.servlet.http.HttpSessionBindingEvent event) {
    dbgSBE("attributeRemoved()", event);
    javax.servlet.http.HttpSession session = event.getSession();
    if (event.getName().equals(com.taglib.authentication.UserSessionManager.SESSION_USER_ATTRIBUTE)) {
      com.taglib.authentication.UserBean user = (com.taglib.authentication.UserBean) event.getValue();
      System.out.println(new java.util.Date().toString()
			 + ": session "
			 + (isTimedOut(session) ? "timeout" : "logout")
			 + " for " + user.getUsername()
			 + " (" + session.getId() + ")");
    }
  }
  private boolean isTimedOut (javax.servlet.http.HttpSession session) {
    try {
      long idle = new java.util.Date().getTime() - session.getLastAccessedTime();
      return idle > (session.getMaxInactiveInterval() * 1000);
    }
    catch (IllegalStateException e) { return true; }
  }

  final static private boolean DBG = false;
  private void dbgSBE (String methodName, javax.servlet.http.HttpSessionBindingEvent event) {
    if (DBG) {
      javax.servlet.http.HttpSession session = event.getSession();
      System.out.println("DBG " + methodName
			 + ": Session " + session.getId() + ", "
			 + event.getName() + " = " + event.getValue());
    }
  }
}
