package com.taglib.authentication;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import javax.servlet.ServletException;
import java.io.IOException;

public class RoleFilter implements javax.servlet.Filter {
  private String role, denyPage;
  private com.taglib.authentication.UserSessionManager sessionMgr;

  public RoleFilter () {
    sessionMgr = com.taglib.authentication.UserSessionManager.getInstance();
  }

  public void init (javax.servlet.FilterConfig config) throws javax.servlet.ServletException {
    role = config.getInitParameter("role");
    if (role == null)
      throw new javax.servlet.ServletException("The role init parameter"
				 + " must be specified.");
    denyPage = config.getInitParameter("denyPage");
    if (denyPage == null)
      throw new javax.servlet.ServletException("The denyPage init parameter"
				 + " must be specified.");
  }


  public void doFilter (javax.servlet.ServletRequest request, javax.servlet.ServletResponse response,
			javax.servlet.FilterChain chain)
    throws java.io.IOException, ServletException {
    if (request instanceof javax.servlet.http.HttpServletRequest
	&& response instanceof javax.servlet.http.HttpServletResponse) {
      javax.servlet.http.HttpServletRequest req = (javax.servlet.http.HttpServletRequest) request;
      javax.servlet.http.HttpSession session = req.getSession(true);
      com.taglib.authentication.UserBean user = sessionMgr.getSessionUser(session);
      if ((user != null) && user.hasRole(role)) {
	chain.doFilter(request, response);
      } else {
	javax.servlet.http.HttpServletResponse resp = (javax.servlet.http.HttpServletResponse) response;
	com.taglib.authentication.UserSessionManager.doRedirect(req, resp, denyPage);
      }
    } else {
      throw new javax.servlet.ServletException("Filter only applicable"
				 + " to HTTP and HTTPS requests.");
    }
  }

  public void destroy () {}
}
