package com.taglib.authentication;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpServletResponseWrapper;
import javax.servlet.ServletOutputStream;

import java.io.OutputStream;
import java.io.ByteArrayOutputStream;
import java.io.ByteArrayInputStream;
import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;

import javax.servlet.ServletException;
import java.io.IOException;

public class StringReplaceFilter implements javax.servlet.Filter {
  private String from, to;

  public StringReplaceFilter () {}

  public void init (javax.servlet.FilterConfig config) throws javax.servlet.ServletException {
    from = config.getInitParameter("from");
    if (from == null)
      throw new javax.servlet.ServletException("The from init parameter"
				 + " must be specified.");
    to = config.getInitParameter("to");
    if (to == null)
      throw new javax.servlet.ServletException("The to init parameter"
				 + " must be specified.");
  }
  public void doFilter (javax.servlet.ServletRequest request, javax.servlet.ServletResponse response,
			javax.servlet.FilterChain chain)
    throws java.io.IOException, ServletException {
    if (request instanceof javax.servlet.http.HttpServletRequest
	&& response instanceof javax.servlet.http.HttpServletResponse) {
      javax.servlet.http.HttpServletRequest req = (javax.servlet.http.HttpServletRequest) request;
      javax.servlet.http.HttpServletResponse resp = (javax.servlet.http.HttpServletResponse) response;
      com.taglib.authentication.StringReplaceFilter.StringReplaceResponse wrappedResponse =
	new com.taglib.authentication.StringReplaceFilter.StringReplaceResponse(resp);
      chain.doFilter(request, wrappedResponse);
      transferData(wrappedResponse, resp);
    } else {
      throw new javax.servlet.ServletException("Filter only applicable"
				 + " to HTTP and HTTPS requests.");
    }
  }
  public void destroy () {}

  private void transferData (com.taglib.authentication.StringReplaceFilter.StringReplaceResponse fromResponse,
			     javax.servlet.http.HttpServletResponse toResponse)
    throws java.io.IOException {
    java.io.ByteArrayInputStream bais = fromResponse.surrogate.getInputStream();
    java.io.BufferedReader reader =
      new java.io.BufferedReader(new InputStreamReader(bais));
    java.io.PrintWriter writer = toResponse.getWriter();
    String line;
    while ((line = reader.readLine()) != null) {
      writer.println(doReplacement(line));
    }
    writer.close();
    reader.close();
  }
  private String doReplacement (String s) {
    int start = s.indexOf(from);
    if (start < 0) {
      return s;
    } else {
      return s.substring(0, start) + to
	+ doReplacement(s.substring(start + from.length()));
    }
  }

  private class StringReplaceResponse extends javax.servlet.http.HttpServletResponseWrapper {
    com.taglib.authentication.StringReplaceFilter.MyServletOutputStream surrogate = new com.taglib.authentication.StringReplaceFilter.MyServletOutputStream();

    private StringReplaceResponse (javax.servlet.http.HttpServletResponse response) {
      super(response);
    }
    public javax.servlet.ServletOutputStream getOutputStream ()
      throws java.io.IOException {
      return surrogate;
    }
    public java.io.PrintWriter getWriter ()
      throws java.io.IOException {
      return new java.io.PrintWriter(new OutputStreamWriter(surrogate));
    }
  }
  private class MyServletOutputStream extends javax.servlet.ServletOutputStream {
    private java.io.ByteArrayOutputStream baos = new java.io.ByteArrayOutputStream(1024);

    public void write (int b) { baos.write(b); }
    public void write (byte[] b, int off, int len) {
      baos.write(b, off, len);
    }

    private java.io.ByteArrayInputStream getInputStream () {
      return new java.io.ByteArrayInputStream(baos.toByteArray());
    }
  }

  static public void main (String[] args) {
    StringReplaceFilter f = new StringReplaceFilter();
    f.from = "s";
    f.to = "th";
    String original = "This is silly, isn't it?";
    System.out.println("ORIGINAL: " + original);
    System.out.println("REPLACED: " + f.doReplacement(original));
  }
}
