package com.taglib.authentication;

import java.util.List;
import java.util.ArrayList;

public class UserBean {
  private long id;
  private String username, fullName, emailAddress;
  private List roles;

  static final public long INVALID_ID = -1;

  public UserBean () {
	this("", "");
  }
  public UserBean (String username, String fullName) {
	this.username = username;
	this.fullName = fullName;
	this.roles = new java.util.ArrayList();
  }

  public long getId () {
    return id;
  }
  public void setId (long id) {
    this.id = id;
  }

  public String getUsername () { return username; }
  public void setUsername (String username) { this.username = username; }

  public String getFullName () { return fullName; }
  public void setFullName (String fullName) { this.fullName = fullName; }

  public String getEmailAddress () {
    return emailAddress;
  }

  public void setEmailAddress (String emailAddress) {
    this.emailAddress = emailAddress;
  }

  public List getRoles () {
    return roles;
  }
  public void setRoles (List roles) {
    this.roles = roles;
  }

  public void addRole (String role) {
	if (! roles.contains(role)) roles.add(role);
    }
    public void removeRole (String role) {
	int index = roles.indexOf(role);
	if (index >= 0) roles.remove(index);
    }
    public boolean hasRole (String role) {
	return roles.contains(role);
    }
}

