package com.taglib.ui;

import javax.servlet.jsp.tagext.Tag;
import javax.servlet.jsp.tagext.TagSupport;
import javax.servlet.jsp.JspWriter;
import javax.servlet.ServletRequest;

import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.BufferedReader;

import javax.servlet.jsp.JspException;
import javax.servlet.ServletException;
import java.io.IOException;

public class BoxTag extends javax.servlet.jsp.tagext.TagSupport {
  private String title;

  public String getTitle () { return title; }
  public void setTitle (String title) { this.title = title; }

  public int doStartTag () throws javax.servlet.jsp.JspException {
    try {
      initIncludes();
      javax.servlet.jsp.JspWriter out = pageContext.getOut();
      out.print(BEFORE_TITLE);
      out.println(title);
      out.print(AFTER_TITLE_BEFORE_BODY);
    }
    catch (java.io.IOException e) { throw new javax.servlet.jsp.JspException(e.toString()); }
    return javax.servlet.jsp.tagext.Tag.EVAL_BODY_INCLUDE;
  }
  public int doEndTag () throws javax.servlet.jsp.JspException {
    javax.servlet.jsp.JspWriter out = pageContext.getOut();
    try {
        out.print(AFTER_BODY);
    }
    catch (java.io.IOException e) { throw new javax.servlet.jsp.JspException(e.toString()); }
    return javax.servlet.jsp.tagext.Tag.EVAL_PAGE;
  }

  static private String BEFORE_TITLE = null;
  static private String AFTER_TITLE_BEFORE_BODY = null;
  static private String AFTER_BODY = null;


  private void initIncludes () throws IOException {
    if (BEFORE_TITLE == null) BEFORE_TITLE = includeToString("/WEB-INF/include/boxtop.inc");
    if (AFTER_TITLE_BEFORE_BODY == null) AFTER_TITLE_BEFORE_BODY = includeToString("/WEB-INF/include/boxmiddle.inc");
    if (AFTER_BODY == null) AFTER_BODY = includeToString("/WEB-INF/include/boxbottom.inc");
  }
  private String includeToString (String includeFile) throws IOException {
    InputStream input = pageContext.getServletContext().getResourceAsStream(includeFile);
    BufferedReader reader = new BufferedReader(new InputStreamReader(input));
    StringBuffer result = new StringBuffer();
    String line;
    while ((line = reader.readLine()) != null) {
      result.append(line);
      result.append('\n');
    }
    return result.toString();
  }
}
