package com.taglib.ui;

import javax.servlet.jsp.PageContext;
import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.tagext.Tag;
import javax.servlet.jsp.tagext.BodyTagSupport;
import javax.servlet.jsp.tagext.BodyContent;
import java.util.Hashtable;

import java.io.IOException;
import javax.servlet.jsp.JspException;

public class EscapeXmlTag extends BodyTagSupport {
  private String style;

  public void setStyle (String style) {
    this.style = style;
  }

  public int doAfterBody () throws JspException {
    BodyContent body = getBodyContent();
    String orig = body.getString();
    body.clearBody();

    int length = orig.length();
    StringBuffer result = new StringBuffer(Math.round(length * 1.1f));
    for (int i = 0; i < length; ++i) {
      char c = orig.charAt(i);
      String translation = getTranslation(c);
      if (translation == null) {
        result.append(c);
      } else {
        result.append(translation);
      }
    }
    try {
      JspWriter writer = getPreviousOut();
      if ((style != null) && (style.length() > 0)) {
        writer.print("<font class=\""); writer.print(style); writer.print("\">");
        writer.print(result.toString());
        writer.print("</font>");
      } else {
        writer.print(result.toString());
      }
    }
    catch (IOException e) {
      throw new JspException("unexpected IO error");
    }
    return Tag.SKIP_BODY;
  }

  public void release () {
    super.release();
    style = null;
  }

  static private Hashtable translations = makeTranslationTable();
  static private Hashtable makeTranslationTable () {
    Hashtable table = new Hashtable();
    table.put(new Character('<'), "&lt;");
    table.put(new Character('>'), "&gt;");
    table.put(new Character('&'), "&amp;");
    table.put(new Character('\n'), "<BR>");
    table.put(new Character('\t'), "&nbsp;&nbsp;");
    return table;
  }
  static public String getTranslation (char c) {
    return (String) translations.get(new Character(c));
  }
}
