/*
 * Created by IntelliJ IDEA.
 * User: mark
 * Date: Nov 2, 2002
 * Time: 10:31:52 AM
 * To change template for new class use
 * Code Style | Class Templates options (Tools | IDE Options).
 */
package com.taglib.util;

import java.sql.Connection;
import javax.sql.DataSource;
import javax.naming.Context;
import javax.naming.InitialContext;

import java.sql.SQLException;
import javax.naming.NamingException;

public class DbConnectionFactory {
  static private DbConnectionFactory INSTANCE = new DbConnectionFactory();
  static public DbConnectionFactory getInstance () { return INSTANCE; }

  private DataSource dataSource = null;
  private DbConnectionFactory () {}

  public Connection getConnection () throws SQLException {
    if (dataSource == null) initDataSource();
    return dataSource.getConnection();
  }

  private void initDataSource () {
    try {
      Context initCtx = new InitialContext();
      Context envCtx = (Context) initCtx.lookup("java:comp/env");
      dataSource = (DataSource) envCtx.lookup("jdbc/Taglib");
    }
    catch (NamingException e) {
      System.out.println("ERR: Unable to Initialize Data Source (" + e + ")");
    }
  }
}
