package com.taglib.util;

import java.util.ArrayList;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

public class MessageBean {
  private ArrayList msgs;

  public MessageBean () {
    this.msgs = new ArrayList();
  }

  final static public String MESSAGE_BEAN_ATTR = "messages";

  static public MessageBean getInstance (HttpServletRequest request) {
    return getInstance(request.getSession(true));
  }
  static public MessageBean getInstance (HttpSession session) {
    MessageBean bean = (MessageBean) session.getAttribute(MESSAGE_BEAN_ATTR);
    if (bean == null) {
      bean = new MessageBean();
      session.setAttribute(MESSAGE_BEAN_ATTR, bean);
    } else {
      bean.clear();
    }
    return bean;
  }

  public void addMessage (String message) {
    msgs.add(message);
  }
  public void clear () {
    msgs.clear();
  }
  public boolean isEmpty () {
    return msgs.isEmpty();
  }

  public int getMessageSize () {
    return msgs.size();
  }
  public String getMessage (int index) {
    return (String) msgs.get(index);
  }

  public ArrayList getMessageList () {
    return msgs;
  }
}
