/*
 * Created by IntelliJ IDEA.
 * User: mark
 * Date: Nov 2, 2002
 * Time: 9:51:00 PM
 * To change template for new class use
 * Code Style | Class Templates options (Tools | IDE Options).
 */
package com.taglib.weblog;

import com.taglib.authentication.UserBean;
import com.taglib.authentication.UserSessionManager;
import com.taglib.util.MessageBean;
import com.taglib.util.DbConnectionFactory;

import javax.servlet.ServletConfig;
import javax.servlet.RequestDispatcher;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import javax.servlet.ServletException;
import java.io.IOException;

public class DeleteEntryServlet extends javax.servlet.http.HttpServlet {
  private String successPage, failurePage;
  private DbWeblogDataManager weblogMgr;

  public void init (javax.servlet.ServletConfig config) throws javax.servlet.ServletException {
    successPage = config.getInitParameter("successPage");
    if (successPage == null)
      throw new javax.servlet.ServletException("The successPage init parameter must be specified.");
    failurePage = config.getInitParameter("failurePage");
    if (failurePage == null)
      throw new javax.servlet.ServletException("The failurePage init parameter must be specified.");
    weblogMgr = DbWeblogDataManager.getInstance();
  }

  final static private String ID_REQPARM = "id";

  public void doPost (javax.servlet.http.HttpServletRequest request, javax.servlet.http.HttpServletResponse response)
    throws javax.servlet.ServletException, IOException {
    com.taglib.util.MessageBean msgs = com.taglib.util.MessageBean.getInstance(request);
    long id = Entry.INVALID_ID;
    try { id = Long.parseLong(request.getParameter(ID_REQPARM)); }
    catch (NumberFormatException e) {
      msgs.addMessage("Invalid format for entry id. Please try again.");
    }
    if (msgs.isEmpty()) {
      try {
        Entry entry = weblogMgr.fetchEntry(id);
        weblogMgr.deleteEntry(entry);
        doSuccess(request, response);
        return;
      }
      catch (WeblogException e) {
        System.out.println("ERR: unable to delete entry (" + e.getRootCause().toString() + ")");
        msgs.addMessage("Unable to delete entries at this time. Please try again later.");
      }
    }
    doFailure(request, response);
  }

  private void doSuccess (javax.servlet.http.HttpServletRequest request,
			    javax.servlet.http.HttpServletResponse response)
    throws java.io.IOException, ServletException {
    javax.servlet.RequestDispatcher rd = request.getRequestDispatcher(successPage);
    rd.forward(request, response);
  }

  private void doFailure (javax.servlet.http.HttpServletRequest request, javax.servlet.http.HttpServletResponse response)
    throws java.io.IOException, ServletException {
    javax.servlet.RequestDispatcher rd = request.getRequestDispatcher(failurePage);
    rd.forward(request, response);
  }
}
