/*
 * Created by IntelliJ IDEA.
 * User: mark
 * Date: Nov 4, 2002
 * Time: 6:18:26 PM
 * To change template for new class use
 * Code Style | Class Templates options (Tools | IDE Options).
 */
package com.taglib.weblog;

import org.apache.taglibs.standard.lang.support.ExpressionEvaluatorManager;
import javax.servlet.jsp.PageContext;
import javax.servlet.jsp.tagext.Tag;
import javax.servlet.jsp.tagext.TagSupport;

import javax.servlet.jsp.JspException;
import javax.servlet.ServletException;
import java.io.IOException;

public class FetchEntryTag extends TagSupport {
  private String idExpression;
  private String var, scope;
  private DbWeblogDataManager weblogMgr = DbWeblogDataManager.getInstance();

  public void setId (String idExpression) {
    this.idExpression = idExpression;
  }

  public void setVar (String var) {
    this.var = var;
  }

  public void setScope (String scope) {
    this.scope = scope;
  }

  public int doStartTag () throws JspException {
    try {
      Long idValue =
          (Long) ExpressionEvaluatorManager.evaluate("id", idExpression, Long.class, this, pageContext);
      Entry entry = weblogMgr.fetchEntry(idValue.longValue());
      setVar(var, scope, entry);
    }
    catch (WeblogException e) {
      throw new JspException(e.getRootCause());
    }
    return Tag.SKIP_BODY;
  }

  public int doEndTag () throws JspException {
    return Tag.EVAL_PAGE;
  }

  private void setVar (String varName, String varScope, Object value) {
    int scopeVal = PageContext.PAGE_SCOPE;
    if (varScope.equalsIgnoreCase("request")) {
      scopeVal = PageContext.REQUEST_SCOPE;
    } else if (varScope.equalsIgnoreCase("session")) {
      scopeVal = PageContext.SESSION_SCOPE;
    } else if (varScope.equalsIgnoreCase("application")) {
      scopeVal = PageContext.APPLICATION_SCOPE;
    }
    pageContext.setAttribute(varName, value, scopeVal);
  }
}
