/*
 * Created by IntelliJ IDEA.
 * User: mark
 * Date: Nov 4, 2002
 * Time: 2:46:22 PM
 * To change template for new class use
 * Code Style | Class Templates options (Tools | IDE Options).
 */
package com.taglib.weblog;

import javax.servlet.jsp.jstl.core.LoopTagSupport;
import java.util.List;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.Date;

import javax.servlet.jsp.JspTagException;

public class ForRecentDateEntriesTag extends LoopTagSupport {
  private int days = 1;
  private Iterator rdeIterator;
  private DbWeblogDataManager weblogMgr = DbWeblogDataManager.getInstance();

  public void setDays (int days) {
    this.days = days;
  }

  protected void prepare () throws JspTagException {
    List entries = new ArrayList();
    try {
      List dateList = weblogMgr.fetchRecentDates(days);
      Iterator dateIter = dateList.iterator();
      while (dateIter.hasNext()) {
        entries.add(weblogMgr.fetchEntries((Date) dateIter.next()));
      }
    }
    catch (WeblogException e) {
      throw new JspTagException(e.getRootCause().getMessage());
    }
    rdeIterator = entries.iterator();
  }

  protected boolean hasNext () {
    return rdeIterator.hasNext();
  }

  protected Object next () {
    return rdeIterator.next();
  }

  public void release () {
    super.release();
    this.days = 1;
    this.rdeIterator = null;
  }
}
