/*
 * Created by IntelliJ IDEA.
 * User: mark
 * Date: Nov 2, 2002
 * Time: 9:51:00 PM
 * To change template for new class use
 * Code Style | Class Templates options (Tools | IDE Options).
 */
package com.taglib.weblog;

import com.taglib.authentication.UserBean;
import com.taglib.authentication.UserSessionManager;
import com.taglib.util.MessageBean;

import javax.servlet.ServletConfig;
import javax.servlet.RequestDispatcher;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import javax.servlet.ServletException;
import java.io.IOException;

public class NewEntryServlet extends HttpServlet {
  private String successPage, failurePage;
  private UserSessionManager sessionMgr;
  private DbWeblogDataManager weblogMgr;

  public void init (ServletConfig config) throws ServletException {
    successPage = config.getInitParameter("successPage");
    if (successPage == null)
      throw new ServletException("The successPage init parameter must be specified.");
    failurePage = config.getInitParameter("failurePage");
    if (failurePage == null)
      throw new ServletException("The failurePage init parameter must be specified.");
    sessionMgr = UserSessionManager.getInstance();
    weblogMgr = DbWeblogDataManager.getInstance();
  }

  final static private String TITLE_REQPARM = "title";
  final static private String ENTRY_REQPARM = "entry";

  public void doPost (HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
    MessageBean msgs = MessageBean.getInstance(request);
    String text = request.getParameter(ENTRY_REQPARM);
    if (text != null) text = text.trim();
    if ((text == null) || (text.length() == 0)) {
      msgs.addMessage("The entry field is required. Please re-enter.");
      doFailure(request, response);
    } else {
      try {
        Entry newEntry = new Entry();
        UserBean user = sessionMgr.getSessionUser(request);
        String title = request.getParameter(TITLE_REQPARM);
        if (title != null) newEntry.setTitle(title.trim());
        newEntry.setText(text);
        newEntry.setAuthor(user);
        weblogMgr.postEntry(newEntry);
        doSuccess(request, response);
        return;
      }
      catch (WeblogException e) {
        System.out.println("ERR: unable to post new entry (" + e.getRootCause().toString() + ")");
        msgs.addMessage("Unable to add new entries at this time. Please try again later.");
        doFailure(request, response);
      }
    }
  }

  private void doSuccess (HttpServletRequest request,
			    HttpServletResponse response)
    throws IOException, ServletException {
    RequestDispatcher rd = request.getRequestDispatcher(successPage);
    rd.forward(request, response);
  }

  private void doFailure (HttpServletRequest request, HttpServletResponse response)
    throws IOException, ServletException {
    RequestDispatcher rd = request.getRequestDispatcher(failurePage);
    rd.forward(request, response);
  }
}
