/*
 * Created by IntelliJ IDEA.
 * User: mark
 * Date: Nov 4, 2002
 * Time: 9:39:12 PM
 * To change template for new class use
 * Code Style | Class Templates options (Tools | IDE Options).
 */
package com.taglib.weblog;

import javax.servlet.ServletConfig;
import javax.servlet.RequestDispatcher;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.Cookie;

import javax.servlet.ServletException;
import java.io.IOException;

public class PreferencesServlet extends HttpServlet {
  private String successPage, failurePage;

  public void init (ServletConfig config) throws ServletException {
    successPage = config.getInitParameter("successPage");
    if (successPage == null)
      throw new ServletException("The successPage init parameter must be specified.");
    failurePage = config.getInitParameter("failurePage");
    if (failurePage == null)
      throw new ServletException("The failurePage init parameter must be specified.");
  }

  final static private String RSS_REQPARM = "rssFeed";
  final static private String TIMEZONE_REQPARM = "timezone";
  final static public String RSS_COOKIE_NAME = "rssPref";
  final static public String TZ_COOKIE_NAME = "tzPref";

  public void doPost (HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
    String rssFeed = request.getParameter(RSS_REQPARM);
    String timezone = request.getParameter(TIMEZONE_REQPARM);
    Cookie rssCookie = new Cookie(RSS_COOKIE_NAME, rssFeed);
    Cookie tzCookie = new Cookie(TZ_COOKIE_NAME, timezone);
    response.addCookie(rssCookie);
    response.addCookie(tzCookie);
    doSuccess(request, response);
  }

  private void doSuccess (HttpServletRequest request,
			    HttpServletResponse response)
    throws IOException, ServletException {
    RequestDispatcher rd = request.getRequestDispatcher(successPage);
    rd.forward(request, response);
  }

  private void doFailure (HttpServletRequest request, HttpServletResponse response)
    throws IOException, ServletException {
    RequestDispatcher rd = request.getRequestDispatcher(failurePage);
    rd.forward(request, response);
  }
}
