CREATE TABLE IF NOT EXISTS users (
  id		INT AUTO_INCREMENT,
  login		VARCHAR(20) NOT NULL,
  password	VARCHAR(35) NOT NULL,
  tmp_password  INT NOT NULL DEFAULT 0,
  PRIMARY KEY(id),
  UNIQUE(login)
);

CREATE TABLE IF NOT EXISTS profiles (
  id            INT,
  name          TINYTEXT,
  email_address  TINYTEXT,
  created       DATETIME,
  last_modified DATETIME,
  UNIQUE(id)
);

CREATE TABLE IF NOT EXISTS define_roles (
  role_id	INT NOT NULL,
  role_name	VARCHAR(20) NOT NULL,
  PRIMARY KEY(role_id),
  UNIQUE(role_id, role_name)
);

INSERT INTO define_roles (role_id, role_name) VALUES (0, 'User');
INSERT INTO define_roles (role_id, role_name) VALUES (1, 'Author');
INSERT INTO define_roles (role_id, role_name) VALUES (10, 'Admin');

CREATE TABLE IF NOT EXISTS user_roles (
  user_id	INT NOT NULL,
  role_id	INT NOT NULL,
  INDEX(user_id),
  UNIQUE(user_id, role_id)
);
