<%@ taglib prefix="c" uri="http://java.sun.com/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jstl/fmt" %>
<%@ taglib prefix="tldc" uri="/tldc" %>

<table width="100%" border="0"cellspacing="0" cellpadding="0">

<tldc:ifLogin role="Author" var="isAuthor">
  <tr><td align="right" class="blogControl"><a href="<c:url value="/secure/author/newEntry.jsp"/>">[new]</a></td></tr>
</tldc:ifLogin>

<c:set var="timezonePreference"><c:out value="${cookie.tzPref.value}" default="CST"/></c:set>
<fmt:setTimeZone value="${timezonePreference}" scope="page"/>

<tldc:forRecentDateEntries var="entryList" days="3">
  <c:forEach items="${entryList}" var="blogEntry" varStatus="status">
    <c:if test="${status.first}">
      <tr><td align="left" class="blogDate">
            <fmt:formatDate value="${blogEntry.created}" dateStyle="full"/>
      </td></tr>
    </c:if>
    <c:if test="${not empty blogEntry.title}">
      <tr><td align="left" class="blogTitle">
        <c:out value="${blogEntry.title}" escapeXml="false"/>
      </td></tr>
    </c:if>
    <tr><td align="left" class="blogText">
      <c:out value="${blogEntry.text}" escapeXml="false"/>
      <font class="blogPosted">[Posted <fmt:formatDate value="${blogEntry.created}" pattern="h:mm a zz"/>
        by <c:out value="${blogEntry.author.username}"/>]</font>
      <c:if test="${isAuthor}">
        <c:url value="/secure/author/editEntry.jsp" var="editLink">
          <c:param name="id" value="${blogEntry.id}"/>
        </c:url>
        <font class="blogControl"><a href="<c:out value="${editLink}"/>">[edit]</a></font>
      </c:if>
    </td></tr>
    <c:choose>
      <c:when test="${status.last}">
        <tr><td align="left" class="blogTitle">&nbsp;</td></tr>
      </c:when>
      <c:otherwise>
        <tr><td align="left" class="blogControl">&nbsp;</td></tr>
      </c:otherwise>
    </c:choose>
  </c:forEach>
</tldc:forRecentDateEntries>

<tr><td align="right" class="blogControl"><a href="<c:url value="/setPrefs.jsp"/>">[prefs]</a></td></tr>
</table>
