<%@ taglib prefix="c" uri="http://java.sun.com/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jstl/fmt" %>
<%@ taglib prefix="tldc" uri="/tldc" %>

<jsp:include page="/include/header.jsp" flush="false">
  <jsp:param name="title" value="JSTL Blog"/>
</jsp:include>

<tldc:box title="News &amp; Views">
<tldc:forRecentDateEntries var="entryList" days="1">

<fmt:timeZone value="US/Eastern">
  <c:forEach items="${entryList}" var="blogEntry" varStatus="status">
      <c:if test="${status.first}">
        <tr><td align="left" class="blogDate">
          <fmt:formatDate value="${blogEntry.created}" dateStyle="full"/>
        </td></tr>
      </c:if>
      <tr><td align="left" class="blogTitle">
        <c:out value="${blogEntry.title}" escapeXml="false"/>
      </td></tr>
    <tr><td align="left" class="blogText">
      <c:out value="${blogEntry.text}" escapeXml="false"/>
      <font class="blogPosted">
        [My <fmt:formatNumber value="0.02" type="currency"/>
         posted at <fmt:formatDate value="${blogEntry.created}"
                                   pattern="h:mm a zz"/>]
      </font>
    </td></tr>
  </c:forEach>
</fmt:timeZone>

</tldc:forRecentDateEntries>
</tldc:box>

