package sequoia.tags;

import sequoia.PeonFactory;
import sequoia.Peon;

import javax.servlet.jsp.tagext.BodyContent;

import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.JspTagException;
import java.io.Writer;

import org.apache.log4j.Logger;

public class CellDelimiterTag extends javax.servlet.jsp.tagext.BodyTagSupport {
  static Logger logger = Logger.getLogger(CellDelimiterTag.class);

  public int doAfterBody() {
    try {
      logger.debug("CellDelimiter AfterBody");
      BodyContent body = getBodyContent();

      RowHeadTag parent = (RowHeadTag)findAncestorWithClass(this, RowHeadTag.class);

      logger.debug("Setting separator: " + body.getString());
      if (parent == null) {
        throw new JspTagException("nesting error");
      } else {
        logger.debug("ReSetting separator: " + body.getString());
        parent.setCellSeparator(body.getString());
      }
      body.clearBody();
    } catch (Exception e) {
      e.printStackTrace(System.err);
    }
    return SKIP_BODY;
  }
}