package sequoia.tags;

import sequoia.PeonFactory;
import sequoia.Peon;

import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspWriter;
import java.io.Writer;

import javax.servlet.jsp.tagext.BodyContent;

import org.apache.log4j.Logger;

public class ResultSetTag extends javax.servlet.jsp.tagext.BodyTagSupport {
  static Logger logger = Logger.getLogger(ResultSetTag.class);

  private ResultSet resultSet = null;

  public int doStartTag() throws JspException {
    try {
      String badQueryMsg = ((String)pageContext.getAttribute("badquery"));
      if (badQueryMsg != null) {
        return SKIP_BODY;
      }

      boolean result = ((Boolean)pageContext.getAttribute("resultType")).booleanValue();
      if(result) {
        resultSet = (ResultSet)pageContext.getAttribute("resultSet");
        //resultSet = ((Peon)pageContext.getAttribute("peon")).getLastResultSet();

        if(resultSet == null) {
          throw new JspException("ResultSet>doStart> Unable to retrieve ResultSet.");
        }
      } else {
        logger.debug("RSTag: NonReturning set met.");
      }
    } catch (Exception e) {
      e.printStackTrace(System.err);
      throw new JspException(e);
    }
    return EVAL_BODY_INCLUDE;
  }

  public int doAfterBody() {
    try {
      if (resultSet != null) {
        JspWriter out = pageContext.getOut();

        String rowPrefix = "", cellPrefix = "", rowSuffix = "", cellSuffix = "";

        String rowTemplate = (String) pageContext.getAttribute("rowtemplate");
        if(rowTemplate != null) {
          int pos = rowTemplate.indexOf("%s");
          rowPrefix = (pos == -1) ? "" : rowTemplate.substring(0, pos);
          rowSuffix = (pos == -1) ? "" : rowTemplate.substring(pos + "%s".length());
        }

        String cellTemplate = (String) pageContext.getAttribute("celltemplate");
        if(cellTemplate != null) {
          int pos = cellTemplate.indexOf("%s");
          cellPrefix = (pos == -1) ? "" : cellTemplate.substring(0, pos);
          cellSuffix = (pos == -1) ? "" : cellTemplate.substring(pos + "%s".length());
        }

        int rowCount = 0;

        ResultSetMetaData rsmd = resultSet.getMetaData();

        while(resultSet.next()) {
          logger.debug(".");
          rowCount++;
          out.println(rowPrefix);
          for(int i=1; i <= rsmd.getColumnCount(); i++) {
            try {
              out.println(cellPrefix + resultSet.getString(i) + cellSuffix);
            } catch (SQLException e) {
              try {
                out.println(cellPrefix + resultSet.getObject(i) + cellSuffix);
              } catch (SQLException ex) {
                out.println(cellPrefix + "BLOB?" + cellSuffix);
              }
            }
          }
          out.println(rowSuffix);
        }
        logger.info("RowCount:" + rowCount);
      }
    } catch (Exception e) {
      e.printStackTrace(System.err);
    }
    return SKIP_BODY;
  }
}