package sequoia;

import java.sql.Connection;
import java.sql.SQLException;

/**
 * Creates and destroys database <code>Connection</code>s.
 * <p>
 * This abstract class provides abstract methods for
 * creating new <code>Connection</code> and destroying
 * <code>Connection</code> (e. g. disconnecting).
 */
abstract public class ConnectionFactory {
    public abstract Connection connect()
      throws DriverInstatiationError,
             SQLException;
    public abstract void disconnect(Connection c)
      throws SQLException;
}