package sequoia;

import java.sql.Connection;
import java.sql.SQLException;

/**
 * Creates and destroys database <pre>Connection</pre>s.
 * <p>
 * This abstract class provides abstract methods for
 * creating new <pre>Connection</pre> and destroying
 * <pre>Connection</pre> (e. g. disconnecting).
 */
abstract public class ConnectionFactory {
    public abstract Connection connect()
      throws DriverInstatiationError,
             SQLException;
    public abstract void disconnect(Connection c)
      throws SQLException;
}
