package sequoia;

import java.sql.Connection;
import java.sql.SQLException;

import java.sql.DriverManager;
/**
 * Creates <pre>Connection</pre> in primitive way -- connections
 * are not reused, nor poooled.
 *
 * @deprecated This is relict from Sequoia 1.
 */
public class PrimitiveConnectionFactory extends ConnectionFactory {
  public static String alias;
  public static String server;
  public static int portNumber = 0; // <=0 indicates type 2 connection
  public static String userId;
  public static String password;

  public Connection connect()
    throws DriverInstatiationError, SQLException
  {
    try {
      String url = null;
      Connection con = null;

      if (portNumber <= 0) {
        url = "jdbc:mysql:" + alias;
        System.out.println(
          "  Connect to '" + alias + "' database using JDBC type 2 driver." );
        Class.forName("com.mysql.jdbc.Driver");
      } else {
        url = "jdbc:mysql://" + server + ":" + portNumber + "/" + alias;
        System.out.println(
          "  Connect to '" + alias + "' database using JDBC type 4 driver." );
        Class.forName("com.mysql.jdbc.Driver").newInstance();
      }
      System.out.println("  URL was: " + url);

      String query = "jdbc:mysql://" + server + ":" + portNumber + "/" + alias + "?user=" + userId + "&password=" + password;
      System.out.println(query);
      con = DriverManager.getConnection("jdbc:mysql://" + server + ":" + portNumber + "/" + alias + "?user=" + userId + "&password=" + password);

      // enable transactions
      con.setAutoCommit(false);
      return con;
    } catch (ClassNotFoundException e) {
      throw new DriverInstantiationError(e);
    } catch (InstantiationException e) {
      throw new DriverInstantiationError(e);
    } catch (SQLException e) {
      throw e;
    }
  }

  public void disconnect(Connection connection){
    System.out.println();
    System.out.println("  Disconnect from '" + alias + "' database.");

    // makes all changes made since the previous commit/rollback permanent
    // and releases any database locks currrently held by the Connection.
    //con.commit();

    // immediately disconnects from database and releases JDBC resources
    if(!connection.isClosed()) {
      connection.close();
      String status = connection.isClosed() ? "closed" : "not closed";
      System.out.println("DBCF: Connection status: " + status);
    } else {
      System.out.println("DBCF: Connection is already closed");
    }
  }
}